import * as i4 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { NgModule, Injectable, EventEmitter, Output, HostBinding, Input, ChangeDetectionStrategy, Component } from '@angular/core';
import * as i2 from '@skyux/i18n';
import { SkyLibResourcesService, SkyI18nModule } from '@skyux/i18n';
import { Subject, ReplaySubject, zip } from 'rxjs';
import { takeUntil } from 'rxjs/operators';
import { trigger, transition, query, group, style, animate } from '@angular/animations';
import * as i3 from '@skyux/core';

/* istanbul ignore file */
/**
 * NOTICE: DO NOT MODIFY THIS FILE!
 * The contents of this file were automatically generated by
 * the 'ng generate @skyux/i18n:lib-resources-module lib/modules/shared/sky-inline-form' schematic.
 * To update this file, simply rerun the command.
 */
const RESOURCES = {
    'EN-US': {
        skyux_inline_form_button_cancel: { message: 'Cancel' },
        skyux_inline_form_button_delete: { message: 'Delete' },
        skyux_inline_form_button_done: { message: 'Done' },
        skyux_inline_form_button_save: { message: 'Save' },
    },
    'FR-CA': {
        skyux_inline_form_button_cancel: { message: 'Annuler' },
        skyux_inline_form_button_delete: { message: 'Supprimer' },
        skyux_inline_form_button_done: { message: 'Terminé' },
        skyux_inline_form_button_save: { message: 'Sauvegarder' },
    },
};
SkyLibResourcesService.addResources(RESOURCES);
/**
 * Import into any component library module that needs to use resource strings.
 */
class SkyInlineFormResourcesModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.7", ngImport: i0, type: SkyInlineFormResourcesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.2.7", ngImport: i0, type: SkyInlineFormResourcesModule, exports: [SkyI18nModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.2.7", ngImport: i0, type: SkyInlineFormResourcesModule, imports: [SkyI18nModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.7", ngImport: i0, type: SkyInlineFormResourcesModule, decorators: [{
            type: NgModule,
            args: [{
                    exports: [SkyI18nModule],
                }]
        }] });

const skySlideDissolve = trigger('skySlideDissolve', [
    transition('* <=> *', [
        // Expand animations
        query('.sky-slide-dissolve-last:enter', [
            style({ height: 0, opacity: 0 }),
            animate('200ms ease-in', style({ height: '*', opacity: 0 })),
        ], { optional: true }),
        query('.sky-slide-dissolve-last:enter', [
            style({ opacity: 0 }),
            animate('200ms ease-in', style({ opacity: 1 })),
        ], { optional: true }),
        // Collapse animations
        // The expanded content should fade out immediately to prevent
        // any overlap with the read-only content that's returning to the screen.
        query('.sky-slide-dissolve-last:leave', [animate('0ms', style({ opacity: 0 }))], { optional: true }),
        group([
            query('.sky-slide-dissolve-first:enter', [
                style({ opacity: 0, height: 0 }),
                animate('100ms ease-in', style({ opacity: 1, height: '*' })),
            ], { optional: true }),
            query('.sky-slide-dissolve-last:leave', [animate('200ms ease-in', style({ height: 0 }))], { optional: true }),
        ]),
    ]),
]);

const SKY_TABBABLE_SELECTOR = [
    'a[href]',
    'area[href]',
    "input:not([disabled]):not([tabindex='-1'])",
    "button:not([disabled]):not([tabindex='-1'])",
    "select:not([disabled]):not([tabindex='-1'])",
    "textarea:not([disabled]):not([tabindex='-1'])",
    'iframe',
    'object',
    'embed',
    "*[tabindex]:not([tabindex='-1'])",
    '*[contenteditable=true]',
].join(', ');
/**
 * @internal
 */
class SkyInlineFormAdapterService {
    applyAutofocus(inlineFormElementRef) {
        const inputWithAutofocus = inlineFormElementRef.nativeElement.querySelector('[autofocus]');
        if (inputWithAutofocus) {
            inputWithAutofocus.focus();
        }
        else {
            const focusEl = inlineFormElementRef.nativeElement.querySelector('.sky-inline-form-content');
            const focusableChildren = this.#loadFocusableChildren(focusEl);
            this.#focusFirstElement(focusableChildren);
        }
    }
    #loadFocusableChildren(elem) {
        const elements = Array.prototype.slice.call(elem.querySelectorAll(SKY_TABBABLE_SELECTOR));
        return elements.filter((element) => {
            return this.#isVisible(element);
        });
    }
    #isVisible(element) {
        const style = window.getComputedStyle(element);
        const isHidden = style.display === 'none' || style.visibility === 'hidden';
        if (isHidden) {
            return false;
        }
        /* istanbul ignore next */
        const hasBounds = !!(element.offsetWidth ||
            element.offsetHeight ||
            element.getClientRects().length);
        return hasBounds;
    }
    #focusFirstElement(list) {
        if (list.length > 0) {
            list[0].focus();
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.7", ngImport: i0, type: SkyInlineFormAdapterService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.7", ngImport: i0, type: SkyInlineFormAdapterService }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.7", ngImport: i0, type: SkyInlineFormAdapterService, decorators: [{
            type: Injectable
        }] });

var SkyInlineFormButtonLayout;
(function (SkyInlineFormButtonLayout) {
    /**
     * Displays custom buttons.
     */
    SkyInlineFormButtonLayout[SkyInlineFormButtonLayout["Custom"] = 0] = "Custom";
    /**
     * Displays Done and Cancel buttons.
     */
    SkyInlineFormButtonLayout[SkyInlineFormButtonLayout["DoneCancel"] = 1] = "DoneCancel";
    /**
     * Displays Done, Delete, and Cancel buttons.
     */
    SkyInlineFormButtonLayout[SkyInlineFormButtonLayout["DoneDeleteCancel"] = 2] = "DoneDeleteCancel";
    /**
     * Displays Save and Cancel buttons.
     */
    SkyInlineFormButtonLayout[SkyInlineFormButtonLayout["SaveCancel"] = 3] = "SaveCancel";
    /**
     * Displays Save, Delete, and Cancel buttons.
     */
    SkyInlineFormButtonLayout[SkyInlineFormButtonLayout["SaveDeleteCancel"] = 4] = "SaveDeleteCancel";
})(SkyInlineFormButtonLayout || (SkyInlineFormButtonLayout = {}));

/**
 * Renders form content in the current view instead of a separate modal.
 */
class SkyInlineFormComponent {
    /**
     * Configuration options for the buttons to display with the inline form.
     * @required
     */
    set config(value) {
        if (value !== this.#_config && !!value) {
            this.#_config = value;
            this.#setupButtons();
        }
    }
    get config() {
        return this.#_config;
    }
    /**
     * Whether to display the inline form. Users can toggle between displaying
     * and hiding the inline form.
     * @default false
     */
    set showForm(value) {
        this.#_showForm = value;
        /* istanbul ignore else */
        if (value) {
            // setTimeout() prevents applyAutofocus() from firing
            // until after *ngIf has added the form element to the DOM.
            this.#skyAppWindowRef.nativeWindow.setTimeout(() => {
                this.#adapter.applyAutofocus(this.#elementRef);
            });
        }
    }
    get showForm() {
        return this.#_showForm;
    }
    get showFormData() {
        return this.showForm;
    }
    #_config;
    #_showForm;
    #ngUnsubscribe;
    #adapter;
    #elementRef;
    #resourcesService;
    #skyAppWindowRef;
    #changeDetectorRef;
    constructor(adapter, elementRef, resourcesService, skyAppWindowRef, changeDetectorRef) {
        /**
         * Fires when users close the inline form.
         */
        this.close = new EventEmitter();
        this.#_showForm = false;
        this.#ngUnsubscribe = new Subject();
        this.#adapter = adapter;
        this.#elementRef = elementRef;
        this.#resourcesService = resourcesService;
        this.#skyAppWindowRef = skyAppWindowRef;
        this.#changeDetectorRef = changeDetectorRef;
    }
    ngOnInit() {
        this.#setupButtons();
    }
    ngOnDestroy() {
        this.#ngUnsubscribe.next();
        this.#ngUnsubscribe.complete();
        this.close.complete();
    }
    closeInlineForm(event) {
        const args = {
            reason: event.action,
        };
        this.close.emit(args);
    }
    #setupButtons() {
        if (this.#isValidCustomConfig(this.config) &&
            this.config &&
            this.config.buttons) {
            this.buttons = this.#getCustomButtons(this.config.buttons);
            this.#changeDetectorRef.markForCheck();
            return;
        }
        this.#getPresetButtons()
            .pipe(takeUntil(this.#ngUnsubscribe))
            .subscribe((buttons) => {
            this.buttons = buttons;
            this.#changeDetectorRef.markForCheck();
        });
    }
    #getPresetButtons() {
        const emitter = new ReplaySubject(1);
        const buttonType = this.config
            ? this.config.buttonLayout
            : SkyInlineFormButtonLayout.DoneCancel;
        switch (buttonType) {
            /* istanbul ignore next */
            default:
            case SkyInlineFormButtonLayout.DoneCancel:
                zip(this.#resourcesService.getString('skyux_inline_form_button_done'), this.#resourcesService.getString('skyux_inline_form_button_cancel'))
                    .pipe(takeUntil(this.#ngUnsubscribe))
                    .subscribe((values) => {
                    emitter.next([
                        {
                            text: values[0],
                            styleType: 'primary',
                            action: 'done',
                        },
                        {
                            text: values[1],
                            styleType: 'link',
                            action: 'cancel',
                        },
                    ]);
                });
                break;
            case SkyInlineFormButtonLayout.SaveCancel:
                zip(this.#resourcesService.getString('skyux_inline_form_button_save'), this.#resourcesService.getString('skyux_inline_form_button_cancel'))
                    .pipe(takeUntil(this.#ngUnsubscribe))
                    .subscribe((values) => {
                    emitter.next([
                        {
                            text: values[0],
                            styleType: 'primary',
                            action: 'save',
                        },
                        {
                            text: values[1],
                            styleType: 'link',
                            action: 'cancel',
                        },
                    ]);
                });
                break;
            case SkyInlineFormButtonLayout.DoneDeleteCancel:
                zip(this.#resourcesService.getString('skyux_inline_form_button_done'), this.#resourcesService.getString('skyux_inline_form_button_delete'), this.#resourcesService.getString('skyux_inline_form_button_cancel'))
                    .pipe(takeUntil(this.#ngUnsubscribe))
                    .subscribe((values) => {
                    emitter.next([
                        {
                            text: values[0],
                            styleType: 'primary',
                            action: 'done',
                        },
                        {
                            text: values[1],
                            styleType: 'default',
                            action: 'delete',
                        },
                        {
                            text: values[2],
                            styleType: 'link',
                            action: 'cancel',
                        },
                    ]);
                });
                break;
            case SkyInlineFormButtonLayout.SaveDeleteCancel:
                zip(this.#resourcesService.getString('skyux_inline_form_button_save'), this.#resourcesService.getString('skyux_inline_form_button_delete'), this.#resourcesService.getString('skyux_inline_form_button_cancel'))
                    .pipe(takeUntil(this.#ngUnsubscribe))
                    .subscribe((values) => {
                    emitter.next([
                        {
                            text: values[0],
                            styleType: 'primary',
                            action: 'save',
                        },
                        {
                            text: values[1],
                            styleType: 'default',
                            action: 'delete',
                        },
                        {
                            text: values[2],
                            styleType: 'link',
                            action: 'cancel',
                        },
                    ]);
                });
                break;
        }
        return emitter.asObservable();
    }
    #getCustomButtons(buttonConfigs) {
        const buttons = [];
        buttonConfigs.forEach((config) => {
            /* istanbul ignore next */
            const styleType = config.styleType || 'default';
            buttons.push({
                action: config.action,
                disabled: config.disabled,
                styleType: styleType,
                text: config.text,
            });
        });
        return buttons;
    }
    #isValidCustomConfig(config) {
        return (!!config &&
            !!config.buttons &&
            config.buttons.length > 0 &&
            config.buttonLayout === SkyInlineFormButtonLayout.Custom);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.7", ngImport: i0, type: SkyInlineFormComponent, deps: [{ token: SkyInlineFormAdapterService }, { token: i0.ElementRef }, { token: i2.SkyLibResourcesService }, { token: i3.SkyAppWindowRef }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.2.7", type: SkyInlineFormComponent, isStandalone: false, selector: "sky-inline-form", inputs: { config: "config", template: "template", showForm: "showForm" }, outputs: { close: "close" }, host: { properties: { "attr.data-show-form": "this.showFormData" } }, providers: [SkyInlineFormAdapterService], ngImport: i0, template: "<div [@skySlideDissolve]=\"showForm\">\n  @if (!showForm) {\n    <div class=\"sky-slide-dissolve-first\">\n      <ng-content />\n    </div>\n  } @else if (template) {\n    <div class=\"sky-slide-dissolve-last\">\n      <div\n        class=\"sky-inline-form sky-shadow sky-box sky-elevation-1-bordered sky-padding-even-md\"\n      >\n        <div class=\"sky-inline-form-content\">\n          <ng-container [ngTemplateOutlet]=\"template\" />\n        </div>\n        <div class=\"sky-inline-form-footer\">\n          @for (button of buttons; track button.text) {\n            <button\n              class=\"sky-btn {{ 'sky-btn-' + button.styleType }}\"\n              type=\"button\"\n              [disabled]=\"button.disabled ? true : null\"\n              [ngClass]=\"{ 'sky-btn-disabled': button.disabled }\"\n              (click)=\"closeInlineForm(button)\"\n            >\n              {{ button.text }}\n            </button>\n          }\n        </div>\n      </div>\n    </div>\n  }\n</div>\n", styles: [".sky-inline-form:not(.sky-theme-modern *){--sky-override-inline-form-background-color: #eeeeef;--sky-override-inline-form-border: 1px solid #cdcfd2;--sky-override-inline-form-box-shadow: 0 0 5px 0 rgba(0, 0, 0, .3);--sky-override-inline-form-button-margin-right: 5px;--sky-override-inline-form-padding: 10px 10px 10px 10px;--sky-override-inline-form-footer-margin-top: 20px}:host-context(.sky-theme-modern:not(.sky-theme-brand-base)) .sky-inline-form{--sky-override-inline-form-box-shadow: var(--sky-elevation-overflow);--sky-override-inline-form-border: none}.sky-inline-form{background:var(--sky-override-inline-form-background-color, var(--sky-color-background-container-base));border:var(--sky-override-inline-form-border, var(--sky-border-style-elevation) var(--sky-border-width-container-base) var(--sky-color-border-container-base));box-shadow:var(--sky-override-inline-form-box-shadow, var(--sky-elevation-raised-100));padding:var(--sky-override-inline-form-padding, var(--sky-comp-inline_form-space-inset-top) var(--sky-comp-inline_form-space-inset-right) var(--sky-comp-inline_form-space-inset-bottom) var(--sky-comp-inline_form-space-inset-left));width:100%}.sky-inline-form .sky-inline-form-footer{margin-top:var(--sky-override-inline-form-footer-margin-top, var(--sky-space-gap-form-xl))}.sky-inline-form .sky-inline-form-footer button{margin:0 var(--sky-override-inline-form-button-margin-right, var(--sky-space-gap-action_group-m)) 0 0}\n"], dependencies: [{ kind: "directive", type: i4.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i4.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }], animations: [skySlideDissolve], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.7", ngImport: i0, type: SkyInlineFormComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sky-inline-form', changeDetection: ChangeDetectionStrategy.OnPush, providers: [SkyInlineFormAdapterService], animations: [skySlideDissolve], standalone: false, template: "<div [@skySlideDissolve]=\"showForm\">\n  @if (!showForm) {\n    <div class=\"sky-slide-dissolve-first\">\n      <ng-content />\n    </div>\n  } @else if (template) {\n    <div class=\"sky-slide-dissolve-last\">\n      <div\n        class=\"sky-inline-form sky-shadow sky-box sky-elevation-1-bordered sky-padding-even-md\"\n      >\n        <div class=\"sky-inline-form-content\">\n          <ng-container [ngTemplateOutlet]=\"template\" />\n        </div>\n        <div class=\"sky-inline-form-footer\">\n          @for (button of buttons; track button.text) {\n            <button\n              class=\"sky-btn {{ 'sky-btn-' + button.styleType }}\"\n              type=\"button\"\n              [disabled]=\"button.disabled ? true : null\"\n              [ngClass]=\"{ 'sky-btn-disabled': button.disabled }\"\n              (click)=\"closeInlineForm(button)\"\n            >\n              {{ button.text }}\n            </button>\n          }\n        </div>\n      </div>\n    </div>\n  }\n</div>\n", styles: [".sky-inline-form:not(.sky-theme-modern *){--sky-override-inline-form-background-color: #eeeeef;--sky-override-inline-form-border: 1px solid #cdcfd2;--sky-override-inline-form-box-shadow: 0 0 5px 0 rgba(0, 0, 0, .3);--sky-override-inline-form-button-margin-right: 5px;--sky-override-inline-form-padding: 10px 10px 10px 10px;--sky-override-inline-form-footer-margin-top: 20px}:host-context(.sky-theme-modern:not(.sky-theme-brand-base)) .sky-inline-form{--sky-override-inline-form-box-shadow: var(--sky-elevation-overflow);--sky-override-inline-form-border: none}.sky-inline-form{background:var(--sky-override-inline-form-background-color, var(--sky-color-background-container-base));border:var(--sky-override-inline-form-border, var(--sky-border-style-elevation) var(--sky-border-width-container-base) var(--sky-color-border-container-base));box-shadow:var(--sky-override-inline-form-box-shadow, var(--sky-elevation-raised-100));padding:var(--sky-override-inline-form-padding, var(--sky-comp-inline_form-space-inset-top) var(--sky-comp-inline_form-space-inset-right) var(--sky-comp-inline_form-space-inset-bottom) var(--sky-comp-inline_form-space-inset-left));width:100%}.sky-inline-form .sky-inline-form-footer{margin-top:var(--sky-override-inline-form-footer-margin-top, var(--sky-space-gap-form-xl))}.sky-inline-form .sky-inline-form-footer button{margin:0 var(--sky-override-inline-form-button-margin-right, var(--sky-space-gap-action_group-m)) 0 0}\n"] }]
        }], ctorParameters: () => [{ type: SkyInlineFormAdapterService }, { type: i0.ElementRef }, { type: i2.SkyLibResourcesService }, { type: i3.SkyAppWindowRef }, { type: i0.ChangeDetectorRef }], propDecorators: { config: [{
                type: Input
            }], template: [{
                type: Input
            }], showForm: [{
                type: Input
            }], showFormData: [{
                type: HostBinding,
                args: ['attr.data-show-form']
            }], close: [{
                type: Output
            }] } });

class SkyInlineFormModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.7", ngImport: i0, type: SkyInlineFormModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.2.7", ngImport: i0, type: SkyInlineFormModule, declarations: [SkyInlineFormComponent], imports: [CommonModule, SkyInlineFormResourcesModule], exports: [SkyInlineFormComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.2.7", ngImport: i0, type: SkyInlineFormModule, imports: [CommonModule, SkyInlineFormResourcesModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.7", ngImport: i0, type: SkyInlineFormModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [SkyInlineFormComponent],
                    imports: [CommonModule, SkyInlineFormResourcesModule],
                    exports: [SkyInlineFormComponent],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { SkyInlineFormButtonLayout, SkyInlineFormModule, SkyInlineFormComponent as λ1 };
//# sourceMappingURL=skyux-inline-form.mjs.map
