import { ComponentHarness, HarnessPredicate } from '@angular/cdk/testing';
import { SkyInlineFormButtonHarnessFilters } from './inline-form-button-harness.filters';
/**
 * Harness to interact with inline form button component in tests.
 */
export declare class SkyInlineFormButtonHarness extends ComponentHarness {
    /**
     * @internal
     */
    static hostSelector: string;
    /**
     * Gets a `HarnessPredicate` that can be used to search for a
     * `SkyInlineFormButtonHarness` that meets certain criteria.
     */
    static with(filters: SkyInlineFormButtonHarnessFilters): HarnessPredicate<SkyInlineFormButtonHarness>;
    /**
     * Clicks the button.
     */
    click(): Promise<void>;
    /**
     * Gets the button style type.
     */
    getStyleType(): Promise<'primary' | 'link' | 'default'>;
    /**
     * Gets the button text.
     */
    getText(): Promise<string>;
    /**
     * Whether the button is disabled.
     */
    isDisabled(): Promise<boolean>;
}
