import { HarnessPredicate } from '@angular/cdk/testing';
import { SkyQueryableComponentHarness } from '@skyux/core/testing';
import { SkyInlineFormButtonHarness } from './inline-form-button-harness';
import { SkyInlineFormButtonHarnessFilters } from './inline-form-button-harness.filters';
import { SkyInlineFormHarnessFilters } from './inline-form-harness.filters';
import { SkyInlineFormTemplateHarness } from './inline-form-template-harness';
/**
 * Harness to interact with inline form components in tests.
 */
export declare class SkyInlineFormHarness extends SkyQueryableComponentHarness {
    /**
     * @internal
     */
    static hostSelector: string;
    /**
     * Gets a `HarnessPredicate` that can be used to search for a
     * `SkyInlineFormHarness` that meets certain criteria.
     */
    static with(filters: SkyInlineFormHarnessFilters): HarnessPredicate<SkyInlineFormHarness>;
    /**
     * Gets an inline form button that matches the given filters.
     */
    getButton(filters: SkyInlineFormButtonHarnessFilters): Promise<SkyInlineFormButtonHarness | null>;
    /**
     * Gets the inline form's buttons.
     */
    getButtons(filters?: SkyInlineFormButtonHarnessFilters): Promise<SkyInlineFormButtonHarness[]>;
    /**
     * Returns a harness wrapping the inline form's template when expanded.
     */
    getTemplate(): Promise<SkyInlineFormTemplateHarness>;
    /**
     * Whether the inline form is shown.
     */
    isFormExpanded(): Promise<boolean>;
}
